#include "World.h"
#include "Ogre.h"
#include "OgreMath.h"
#include "OgreSceneManager.h"
#include "OgreSceneNode.h"
#include "OgreVector3.h"
#include "OgreSphere.h"
#include "MovingObject.h"

using namespace Ogre;

World::World(Ogre::SceneManager *sceneManager) : mSceneManager(sceneManager)
{
    mSceneManager->setAmbientLight(ColourValue(1,1,1));
    Setup();
}

void World::Setup()
{
    mObj1 = new MovingObject(mSceneManager, "MyCube.mesh", NULL);
    mObj2 = new MovingObject(mSceneManager, "MyCube.mesh", mObj1);
    mObj3 = new MovingObject(mSceneManager, "MyCube.mesh", mObj2);
    
    mObj2->setPosition(Ogre::Vector3(20, 0, 0));
    mObj3->setPosition(Ogre::Vector3(0, 20, 0));
}

void 
World::Think(float time)
{
    mObj1->yaw(Ogre::Radian(0.5f * time));
    mObj2->pitch(Ogre::Radian(0.6f * time));
    mObj3->roll(Ogre::Radian(0.5f * time));
}


